<?php

if (!defined('SMF'))
	die('Hacking attempt...');

// Export Your PMs, not talking about your girl.
// !!! THIS IS ONLY USED FOR SMF 1.1, as of SMF 2.0 this is now done properly in PersonalMessages.php
function ExportMessagesXML()
{
	global $db_prefix, $ID_MEMBER, $scripturl, $user_info, $context, $txt;

	// Only want a single folder? Fine then..
	if(isset($_REQUEST['l']) && (isset($context['labels'][$_REQUEST['l']]) || $_REQUEST['l'] == -1 ))
		$folder = (int) $_REQUEST['l'];

	// Find all Messages to export...
	$request = db_query("
		SELECT pm.ID_PM, pm.ID_MEMBER_FROM, pm.fromName, pm.msgtime, pm.subject, pm.body, pmr.labels, mem_to.messageLabels
		FROM ({$db_prefix}personal_messages AS pm, {$db_prefix}pm_recipients AS pmr)
			LEFT JOIN {$db_prefix}members AS mem_to ON (mem_to.ID_MEMBER = pmr.ID_MEMBER)
		WHERE pmr.ID_PM = pm.ID_PM
			AND pmr.ID_MEMBER = $ID_MEMBER
			AND pmr.deleted = 0" . (isset($folder) ? "
			AND FIND_IN_SET('$folder', pmr.labels)" : '') . "
		ORDER BY pmr.ID_PM DESC", __FILE__, __LINE__);

	// Load the ID_PMs and ID_MEMBERs and initialize recipients.
	$pms = array();
	$pmessages = array();
	while ($row = mysql_fetch_assoc($request))
	{
		// We need this to get the recipients.
		$pms[] = $row['ID_PM'];

		// This is the main stuff though.
		$pmessages[$row['ID_PM']] = array(
			'id' => $row['ID_PM'],
			'from' => array(
				'id' => $row['ID_MEMBER_FROM'],
				'name' => $row['fromName'],
			),
			'recipients' => array(
				'to' => array(),
				'bbc' => array(),
			),
			'labels' => explode(',', $row['labels']),
			'sent' => timeformat($row['msgtime'], false),
			'subject' => $row['subject'],
			'body' => parse_bbc($row['body'], 'print'),
		);

		$templables = explode(',', $row['messageLabels']);
		foreach ($pmessages[$row['ID_PM']]['labels'] as $num => $label)
		{
			if($label == -1)
				$templables[$label] = 'inbox';

			$pmessages[$row['ID_PM']]['labels'][$num] = $templables[$label];
		}
	}
	mysql_free_result($request);

	if(empty($pms))
		fatal_lang_error('exportpms_none', false);

	// Get recipients (don't include bcc-recipients for your inbox, you're not supposed to know :P).
	$request = db_query("
		SELECT pmr.ID_PM, mem_to.ID_MEMBER AS ID_MEMBER_TO, mem_to.realName AS toName, pmr.bcc, pmr.labels, pmr.is_read
		FROM {$db_prefix}pm_recipients AS pmr
			LEFT JOIN {$db_prefix}members AS mem_to ON (mem_to.ID_MEMBER = pmr.ID_MEMBER)
		WHERE pmr.ID_PM IN (" . implode(', ', $pms) . ")", __FILE__, __LINE__);

	while ($row = mysql_fetch_assoc($request))
	{
		if (empty($row['bcc']))
			$pmessages[$row['ID_PM']]['recipients'][empty($row['bcc']) ? 'to' : 'bcc'][] = array (
				'id' => $row['ID_MEMBER_TO'],
				'name' => $row['toName'],
				);

	}

	mysql_free_result($request);

	// Get rid of the gzipping alreading being done.
	if (!empty($modSettings['enableCompressedOutput']))
		@ob_end_clean();
	// If we can, clean anything already sent from the output buffer...
	elseif (function_exists('ob_clean') && ob_get_length() != 0)
		ob_clean();

	// Tell the client to save this file, even though it's text.
	header('Content-Type: application/octetstream');
	header('Content-Encoding: none');

	// Send the proper headers to let them download this file.
	header('Content-Disposition: filename="PMs_' . (isset($folder) ? 'label-' . ($folder = -1 ? 'inbox' : $folder) : 'ALL') . '_' . strftime('%Y-%m-%d') .'.xml"');
	header('Cache-Control: private');
	header('Connection: close');

	echo '<?xml version="1.0" encoding="', $txt['lang_character_set'], '"?>
<smf:xml-personalmessages xmlns:smf="http://www.simplemachines.org/" xmlns="http://www.simplemachines.org/xml/export-personal-messages" xml:lang="', $txt['lang_locale'], '">';

	// Output Time..
	foreach($pmessages as $msg)
	{
		// Stuff we need to set.
		$rcp_start = true;
		$labl_start = true;

		// Start Output..
		echo '
	<personalmesssage>
		<from><![CDATA[', $msg['from']['name'], ' (#', $msg['from']['id'], ')]]></from>
		<recipients><![CDATA[';

		// For Everyone it went to besides BBC (Cuss you shouldn't know) tell us
		foreach ($msg['recipients']['to'] as $rcp)
			echo ($rcp_start ? ($rcp_start = false) : ', '), $rcp['name'], ' (#', $rcp['id'], ')';

		// Folders are next
		echo ']]></recipients>
		<labels><![CDATA[';

		// For every folder we tell.
		foreach ($msg['labels'] as $labl)
			echo ($labl_start ? ($labl_start = false) : ', '), $labl;

		echo ']]></labels>
		<sent><![CDATA[', $msg['sent'], ']]></sent>
		<subject><![CDATA[', $msg['subject'], ']]></subject>
		<message><![CDATA[', $msg['body'], ']]></message>
	</personalmesssage>';
	}

	echo '
</smf:xml-personalmessages>';

	exit;
}
?>